/*========================================================================*
 * TITLE:	Qwik Mail Reader for Unix/Linux
 * MODULE:	reply.c -- Handle the reply edits etc.
 * BY:		Ross C LINDER	(c) 1994 All rights reserved
 *
 * X11-QMR is Copyright (c) 1994 of Ross C Linder. X11-QMR is not public
 * domain. Permission is granted to use and distribute X11-QMR freely.
 * 
 * The only restriction is that you may not distibute modified source
 * code, and that you do not attempt to prevent others from having free
 * access to the source.
 *========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <Xm/Text.h>
#include "qwk.h"

static char id[]=

"@(#)reply.c	$Revision: 1.1 $	$Date: 1994/07/24 17:49:31 $";

/*========================================================================*/

u_char		reg_id[] = "\376 X11-QMR 1.1 \376";
char		tag_line[80] = " Linux -- a kind of magic";


extern Widget	msg_text, head_dialog, head_to_text, head_subj_text;
extern Widget	env_dialog, lp_text, spell_text, xedit_text, tagpath_text;
extern Widget	pub_tb;

extern char	bbs_tagfile[];
extern char	bbs_printcmd[];
extern char	bbs_spellcmd[];
extern char	bbs_xeditcmd[];
extern char	bbs_user[];
extern char	bbs_path[];
extern char	bbs_name[];
extern char	last_dmsg[];
extern QWKHDR	extr_hdr;
QWKHDR		reply_hdr;

/*========================================================================*
 * NEW_MSG -- Clear the msg text for a new message, pop up the
 *            message header dialog
 *========================================================================*/

new_msg ()
{
int		a, c;
struct tm	*tm;

    XmToggleButtonSetState (pub_tb, 1, 1);	/* Default Public */

    reply_hdr.status = QWK_PUBLIC;
    reply_hdr.msgnum = extr_hdr.confnum;	/* This a reply */
    reply_hdr.date = time (0);
    strcpy (reply_hdr.to, "ALL");
    strcpy (reply_hdr.from, bbs_user);
    strcpy (reply_hdr.subj, "");
    reply_hdr.repnum = 0;
    reply_hdr.numchunks = 0;
    reply_hdr.live = 'a';
    reply_hdr.confnum = extr_hdr.confnum;

    XmTextSetString (msg_text, "");

    display_header (&reply_hdr);
    edit_reply_header ();
}

/*========================================================================*
 * REPLY_TO_MSG -- Copy the current message to the message text
 *                 after adding the senders initials. Set header etc.
 *========================================================================*/

reply_to_msg ()
{
FILE		*fp, *fpo;
static char	*msgbuf;
char		ebuf[256];
char		fname[256];
struct stat	st;
int		a, c;
struct tm	*tm;

    XmToggleButtonSetState (pub_tb, 1, 1);

    if ((fp = fopen (last_dmsg, "r")) == NULL) {
	sprintf (ebuf, "Error: %s\n       %s", last_dmsg, strerror (errno));
	error_dialog (ebuf, "OK", "", "", NULL);
	return;
	}

    strcpy (fname, bbs_path);
    strcat (fname, "/reply");

    if ((fpo = fopen (fname, "w")) == NULL) {
	sprintf (ebuf, "Error: %s\n       %s", fname, strerror (errno));
	error_dialog (ebuf, "OK", "", "", NULL);
	fclose (fp);
	return;
	}

    reply_hdr.status = QWK_PUBLIC;
    reply_hdr.msgnum = extr_hdr.confnum;	/* This a reply */
    reply_hdr.date = time (0);
    strcpy (reply_hdr.to, extr_hdr.from);
    strcpy (reply_hdr.from, bbs_user);
    strcpy (reply_hdr.subj, extr_hdr.subj);
    reply_hdr.repnum = 0;
    reply_hdr.numchunks = 0;
    reply_hdr.live = 'a';
    reply_hdr.confnum = extr_hdr.confnum;

    tm = localtime (&extr_hdr.date);
    strcpy (fname, asctime (tm));
    fname[strlen (fname) - 15] = 0;

    fprintf (fpo, "On %s, in a message to ", fname);

    strcpy (fname, extr_hdr.to);
    dual_case (fname);
    fprintf (fpo, "%s\n", fname);

    strcpy (fname, extr_hdr.from);
    dual_case (fname);
    fprintf (fpo, "%s, stated that ..\n\n", fname);

    ebuf[0] = fname[0];
    a = 1;
    while (!isupper (fname[a]) && fname[a])
	a++;
	
    if (fname[a])
	ebuf[1] = fname[a];
    else
	ebuf[1] = '@';

    ebuf[2] = '>'; ebuf[3] = ' ';

    for (;;) {
	if (feof (fp))
	    break;
    
	fgets (&ebuf[4], 80, fp);
	fputs (ebuf, fpo);
	}

    fclose (fp);
    fclose (fpo);


    strcpy (fname, bbs_path);
    strcat (fname, "/reply");

    if (stat (fname, &st) == -1) {
	sprintf (ebuf, "Error: %s\n       %s", last_dmsg, strerror (errno));
	error_dialog (ebuf, "OK", "", "", NULL);
	return;
	}

    if ((fp = fopen (fname, "r")) == NULL) {
	sprintf (ebuf, "Error: %s\n       %s", fname, strerror (errno));
	error_dialog (ebuf, "OK", "", "", NULL);
	return;
	}

    if ((msgbuf = calloc (st.st_size + 1000, 1)) == NULL) {
	sprintf (ebuf, "Error: %s", strerror (errno));
	error_dialog (ebuf, "OK", "", "", NULL);
	fclose (fp);
	return;
	}

    a = 0;
    for (;;) {
	if ((c = fgetc (fp)) == 0x0d)
	    continue;
	if (c == -1)
	    break;
	msgbuf[a++] = c;
	}

    fclose (fp);

    XmTextSetString (msg_text, msgbuf);

    display_header (&reply_hdr);

    free (msgbuf);
}


/*========================================================================*
 * DUAL_CASE -- Turn ABC DEF to Abc Def, a freindly name <g>
 *========================================================================*/

dual_case (char *name)
{
int	a;

    a = 1;
    while (name[a] && name[a] != ' ') {
	name[a] = tolower (name[a]);
	a++;
	}

    if (name[a]) {
	a += 2;
	while (name[a] && name[a] != ' ') {
	    name[a] = tolower (name[a]);
	    a++;
	    }
	}
}

/*========================================================================*
 * EDIT_REPLY_HEADER -- Change details in the reply message header
 *========================================================================*/

edit_reply_header ()
{
    XmTextSetString (head_to_text, reply_hdr.to);
    XmTextSetString (head_subj_text, reply_hdr.subj);
    XtManageChild (head_dialog);
}


/*========================================================================*
 * HEAD_EIDT_CB -- Calback for the Edit header dialog
 *                 Set the destiantion, mode, and subject
 *========================================================================*/

void head_edit_cb ()
{
char	*tp;
int	a;

    tp = XmTextGetString (head_to_text);

    for (a = 0; tp[a] && a < 25; a++)
	reply_hdr.to[a] = toupper (tp[a]);

    reply_hdr.to[a] = 0;

    XtFree (tp);

    tp = XmTextGetString (head_subj_text);
    strncpy (reply_hdr.subj, tp, 25);
    XtFree (tp);

    if (XmToggleButtonGetState (pub_tb))
	reply_hdr.status = QWK_PUBLIC;
    else
	reply_hdr.status = QWK_PRIVATE;

    display_header (&reply_hdr);
}

/*========================================================================*
 * ENV_CB -- Edit Environment dialog callback, save new settings
 *========================================================================*/

void env_cb ()
{
FILE	*fp;
char	fname[256];
char	ebuf[256];
char	*tp;
int	a;

    sprintf (fname, "%s/QMR/config", getenv ("HOME"));
    if ((fp = fopen (fname, "w")) == NULL) {
	sprintf (ebuf, "Error: %s\n       %s", fname, strerror (errno));
	error_dialog (ebuf, "OK", "", "", NULL);
	return;
	}

    tp = XmTextGetString (lp_text);
    fprintf (fp, "%s\n", tp);
    XtFree (tp);

    tp = XmTextGetString (spell_text);
    fprintf (fp, "%s\n", tp);
    XtFree (tp);

    tp = XmTextGetString (xedit_text);
    fprintf (fp, "%s\n", tp);
    XtFree (tp);

    tp = XmTextGetString (tagpath_text);
    fprintf (fp, "%s\n", tp);
    XtFree (tp);

    fprintf (fp, "%s\n", tag_line);

    fclose (fp);

    read_qmr_config ();
}


/*========================================================================*
 * READ_QMR_CONFIG -- Read the configuration environment from the
 *                    users config file. Assume defaults if it does
 *                    not exist, but warn luser.
 *========================================================================*/

read_qmr_config ()
{
FILE	*fp;
char	fname[256];
char	ebuf[256];
char	*tp;
int	a;

    sprintf (fname, "%s/QMR/config", getenv ("HOME"));
    if ((fp = fopen (fname, "r")) == NULL) {
	sprintf (ebuf, "Warning: %s\n       %s\nMaking default assumtions",
			fname, strerror (errno));
	warn_dialog (ebuf, "OK", "", "", NULL);
	return;
	}

    if (fgets (ebuf, 80, fp)) {
	ebuf[strlen (ebuf) - 1] = 0;
	strcpy (bbs_printcmd, ebuf);
	}

    if (fgets (ebuf, 80, fp)) {
	ebuf[strlen (ebuf) - 1] = 0;
	strcpy (bbs_spellcmd, ebuf);
	}

    if (fgets (ebuf, 80, fp)) {
	ebuf[strlen (ebuf) - 1] = 0;
	strcpy (bbs_xeditcmd, ebuf);
	}

    if (fgets (ebuf, 80, fp)) {
	ebuf[strlen (ebuf) - 1] = 0;
	strcpy (bbs_tagfile, ebuf);
	}

    if (fgets (ebuf, 80, fp)) {
	ebuf[strlen (ebuf) - 1] = 0;
	ebuf[60] = 0;
	strcpy (tag_line, ebuf);
	}

    fclose (fp);
}


/*========================================================================*
 * WRITE_QMR_CONFIG -- Save the current config environment to the
 *                     users config file.
 *========================================================================*/

write_qmr_config ()
{
FILE	*fp;
char	fname[256];
char	ebuf[256];
char	*tp;
int	a;

    sprintf (fname, "%s/QMR/config", getenv ("HOME"));
    if ((fp = fopen (fname, "w")) == NULL) {
	sprintf (ebuf, "Warning: Can't update config\n%s",
			fname, strerror (errno));
	warn_dialog (ebuf, "OK", "", "", NULL);
	return;
	}

    fprintf (fp, "%s\n", bbs_printcmd);
    fprintf (fp, "%s\n", bbs_spellcmd);
    fprintf (fp, "%s\n", bbs_xeditcmd);
    fprintf (fp, "%s\n", bbs_tagfile);
    fprintf (fp, "%s\n", tag_line);
    fclose (fp);
}


/*========================================================================*
 * MAIL_REPLY_MSG -- Add the current message to the reply packet
 *========================================================================*/

mail_reply_msg ()
{
FILE		*fp;
FILE		*fpsig;
char		fname[256], *src, *sp;
char		ebuf[256];
SHT_QWKHDR	h;
int		len;

    strcpy (fname, bbs_path);
    strcat (fname, "/");
    strcat (fname, bbs_name);
    strcat (fname, ".msg");

    if ((fp = fopen (fname, "a+")) == NULL) {
	sprintf (ebuf, "Error: %s\n       %s", fname, strerror (errno));
	error_dialog (ebuf, "OK", "", "", NULL);
	return;
	}

    src = XmTextGetString (msg_text);

    sp = calloc (strlen (src) + 3000, 1);	/* 3000 for sig & tag */

    strcpy (sp, src);
    XtFree (src);
    src = sp;

    break_lines (src);

    sprintf (fname, "%s/QMR/signature", getenv ("HOME"));
    if ((fpsig = fopen (fname, "r")) != NULL) {
	while (fgets (ebuf, 80, fpsig) != NULL)
	    strcpy (&src[strlen (src)], ebuf);
	fclose (fpsig);
	}

    sprintf (&src[strlen (src)], "\n%s %s\n", reg_id, tag_line);

    reply_hdr.numchunks = (strlen (src) / QWK_BLK) +
			  ((strlen (src) % QWK_BLK) ? 2 : 1);

    h.status  = reply_hdr.status;
    sprintf (h.msgnum, "%-7d", reply_hdr.confnum);
    strftime (h.date, 14, "%m-%d-%y%H:%M", localtime (&reply_hdr.date));
    sprintf (h.to, "%-25.25s", reply_hdr.to);
    sprintf (h.from, "%-25.25s", reply_hdr.from);
    sprintf (h.subj, "%-25.25s", reply_hdr.subj);
    memset (h.pword, ' ', 12);
    sprintf (h.repnum, "%-8d", reply_hdr.repnum);
    sprintf (h.numchunks, "%-6d", reply_hdr.numchunks);
    h.live = 0xE1;	/* Live */
    h.confnum[0] = (u_char)(reply_hdr.confnum & 255);
    h.confnum[1] = (u_char)((reply_hdr.confnum >> 8) & 255);

    if (!fwrite (&h, QWK_BLK, 1, fp)) {
	sprintf (ebuf, "Error: %s\n       %s", fname, strerror (errno));
	error_dialog (ebuf, "OK", "", "", NULL);
	fclose (fp);
	free (src);
	return;
	}
	
    sp = src;
    while (sp = strchr (sp, '\n'))
	*sp = 0xE3;			/* Arshole eol */

    len = strlen (src);

    fwrite (src, 1, len, fp);

    while (len < QWK_BLK * (reply_hdr.numchunks - 1)) {
	fputc (' ', fp);
	len++;
	}

    fclose (fp);

    free (src);
}


/*========================================================================*
 * SPELL_CHECK_REPLY -- Run an external spelling checker on the reply
 *
 * NOTE: Ispell is recomended, and used by default.
 *========================================================================*/

spell_check_reply ()
{
FILE	*fp;
char	cmd[256], ebuf[256];
char	*src;

    strcpy (cmd, bbs_path);
    strcat (cmd, "/reply");

    if ((fp = fopen (cmd, "w")) == NULL) {
	sprintf (ebuf, "Error: %s\n       %s", cmd, strerror (errno));
	error_dialog (ebuf, "OK", "", "", NULL);
	return;
	}
	
    src = XmTextGetString (msg_text);
    break_lines (src);

    fwrite (src, 1, strlen (src), fp);
    fclose (fp);

    XtFree (src);

    sprintf (cmd, "%s %s/reply", bbs_spellcmd, bbs_path);
    if (system (cmd) == 0) {
	strcpy (cmd, bbs_path);
	strcat (cmd, "/reply");
	file_to_msg (cmd, 1);
	}
    else
	error_dialog ("Problem Spell Checking", "OK", "", "", NULL);
}


/*========================================================================*
 * FORMAT_REPLY -- Limit the with of a line to 75 chars so that when
 *                 the message is replied to, it still is neat for
 *                 most offline mail readers. This might need to
 *                 become 72. Yuk !
 *========================================================================*/

format_reply ()
{
char	*src;

    src = XmTextGetString (msg_text);
    break_lines (src);

    XmTextSetString (msg_text, src);

    XtFree (src);
}


/*========================================================================*
 * EXT_EDIT_REPLY -- Edit the reply using the external editor.
 *
 * NOTE: This uses "vi" by default, the best editor ever created
 *========================================================================*/

ext_edit_reply ()
{
FILE	*fp;
char	cmd[256], ebuf[256];
char	*src;

    strcpy (cmd, bbs_path);
    strcat (cmd, "/reply");

    if ((fp = fopen (cmd, "w")) == NULL) {
	sprintf (ebuf, "Error: %s\n       %s", cmd, strerror (errno));
	error_dialog (ebuf, "OK", "", "", NULL);
	return;
	}
	
    src = XmTextGetString (msg_text);
    break_lines (src);

    fwrite (src, 1, strlen (src), fp);
    fclose (fp);

    XtFree (src);

    sprintf (cmd, "%s %s/reply", bbs_xeditcmd, bbs_path);
    if (system (cmd) == 0) {
	strcpy (cmd, bbs_path);
	strcat (cmd, "/reply");
	file_to_msg (cmd, 1);
	}
    else
	error_dialog ("Problem executing external editor", "OK", "", "", NULL);
}


/*========================================================================*
 * BREAK_LINES -- Split the lines of source into lines of not more than
 *                75 Chars for sender, and 79 Chars for quotee
 *========================================================================*/

break_lines (char *s)
{
int	a, b, c, snip;

    a = 0;
    b = 0;

    for (;;) {
	if (s[a] == 0)
	    break;

	if (s[a+2] == '>' || s[a] == '\376')	/* Quotee or Tag ? */
	    snip = 79;
	else
	    snip = 75;

	for (b = a; b < a + snip; b++) {
	    if (s[b] == 0)
		return;
	    if (s[b] == '\n')
		break;
	    }

	if (b != a + snip) {
	    b++;
	    a = b;
	    continue;
	    }

	while (s[b] != ' ' && b && s[b] != '\n')
	    b--;

	if (b > a) {
	    s[b] = '\n';
	    c = 1;
	    for (;; c++) {
	    	if (!s[b+c])
	    	    break;			/* End of Text */
		if (s[b+c] == '\n') {		/* Join next line */
		    if (s[b+c+1] != '\n')	/* unless paragraph */
			s[b+c] = ' ';
		    break;
		    }
		}
	    }
	else {
	    b++;
	    while (s[b] != ' ' && s[b] != '\n' && s[b]) /* cant break line */
		b++;
	    }

	if (s[b])
	    a = b + 1;
	else
	    a = b;
	}
}

/*========================================================================*
 * $Log: reply.c,v $
 * Revision 1.1  1994/07/24  17:49:31  ross
 * Initial revision
 *
 *========================================================================*/
